多校联合训练第五场总结

先把我们ac的几道简单题捋捋,剩下的题以后再搞

1002:http://acm.hdu.edu.cn/showproblem.php?pid=5344

题意:根据题中所给公式,求出a[n]数组,然后对所有的(Ai+Aj)(1≤i,j≤n)求异或

思路:根据疑惑的性质,相同得0,不同为1,0和其他数异或还是原数,故对于不同的i,j,都有对应j,i使得两个数相等,这样两个相同的数异或就得0,最后只剩这些数本身的二倍做异或

代码:

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cctype>
#include <numeric>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <fstream>
#define debug "output for debug\n"
#define pi (acos(-1.0))
#define eps (1e-8)
#define inf 0x3f3f3f3f
#define ll long long
using namespace std;
const int maxn = 10000005;
ll a[maxn];
int main()
{
    int t;
    int m,n,z,l;
    ll sum;

    scanf("%d",&t);
    while(t--)
    {
        sum=0;
        scanf("%d%d%d%d",&n,&m,&z,&l);
        a[0]=0;
        for(int i=1;i<n;i++)
        {
            a[i]=(a[i-1]*m+z)%l;
            sum^=(2*a[i]);
        }
        printf("%I64d\n",sum);
    }
    return 0;
}

1005:http://acm.hdu.edu.cn/showproblem.php?pid=5347

题意:高中化学题,比较第一电离能

思路:百度到第一电离能,然后比较一下就行

代码:

#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdio>
#include <iomanip>
#include <queue>
#include <ctime>
#include <ctype.h>
#define maxn 1000005
#define INF 12222
#define ll long long
using namespace std; 

int u,v;
int f[200]={0,1312,2372.3,520.2,932,800.6,1086.5,1402.3,1313.9,1681,2080.7,495.8,737.7,577.5,786.5,1011.8,999.6,1251.2,1520.6,
418.8,589.8,633.1,658.8,650.9,652.9,717.3,762.5,760.4,737.1,745.5,906.4,578.8,762,947,941,1139.9,1350.8,403,549.5,600,640.1,652.1,
684.3,702,710.2,719.7,804.4,731,867.8,558.3,708.6,834,869.3,1008.4,1170.4,375.7,502.9,538.1,534.4,527,533.1,540,544.5,547.1,593.4,
565.8,573,581,589.3,596.7,603.4,523.5,658.5,761,770,760,840,880,870,890.1,1007.1,589.4,715.6,703,812.1,890,1037,380,509.3,499,587
,568,597.6,604.5,584.7,578,581,601,608,619,627,635,642,470,580,};

int main()
{
    while(cin>>u>>v)
    {
        if(f[u]>f[v])
        {
            cout<<"FIRST BIGGER"<<endl;
        }
        if(f[u]<=f[v])
        {
            cout<<"SECOND BIGGER"<<endl;
        }
    }
    return 0;
}

1007:http://acm.hdu.edu.cn/showproblem.php?pid=5349

题意:给你n个操作,1代表往里面加一个数字,2代表删除最小的数字,3代表找出最大的数字

思路:不用专门的set,直接维护最大值就好,如果只剩一个数字,删除后最大值就用负无穷来赋值

代码:

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cctype>
#include <numeric>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <fstream>
#define debug "output for debug\n"
#define pi (acos(-1.0))
#define eps (1e-8)
#define inf 0x3f3f3f3f
#define ll long long
using namespace std;
const int maxn = 100005;
int main()
{
    int t;
    int x;
    int a;
    int ma;
    int sum;
    sum=0;
    ma=-inf;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&x);
        if(x==1)
        {
           scanf("%d",&a);
           sum++;
           if(a>ma)
              ma=a;

        }
        else if(x==2)
        {
            if(sum==1)
            {
                ma=-inf;
            }
            if(sum==0)
                continue;
            sum--;
        }
        else
        {
            if(sum==0)
                printf("0\n");
            else
            printf("%d\n",ma);
        }
    }
    return 0;

}

剩下的以后再说、、、

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-24 12:21:29

多校联合训练第五场总结的相关文章

多校联合训练第三场

1011 签到题,做过最简单的签到题... 1 #include<cstdio> 2 #include<cstring> 3 #include<iostream> 4 #include<algorithm> 5 #include<cmath> 6 #include<vector> 7 #include<set> 8 #include<string> 9 #include<sstream> 10 #i

2015年多校联合训练第四场(Olympiad)hdu5327

题意:找区间美丽数(自身有不同数字组成的数,如123是,100不是)的个数 思路:打表 #include <bits/stdc++.h> #define LL long long using namespace std; int a[1001005]; int n; int f[100005]; int sum[100005]; int flag[10]; void init() { for(int i = 1; i <= 100000; i++) { memset(flag,0,siz

2015年多校联合训练第四场(Problem Killer)hdu5328

题意: 求最大等差或等比数列的长度 思路: 开始用二分,WA暴了,后来发现我用的等差数列公式有问题 (a[i]+a[j])*(j-i+1)/2,等差数列一定满足这个公式,但满足这个公式的不一定是等差数列,我sb了..... 还有就算等比数列a[i+1]/a[i] == a[i]/a[i-1],也是sb了,这个会引起精度丢失,应该a[i]^2 = a[i-1]*a[i+1]; --. 正解应该是不管等差还是等比数列,如果a,b,c是等差,b,c,d是等差,那么a,b,c,d肯定是等差 然后扫一遍就

HDU OJ 5326 Work( 2015多校联合训练第3场) 并查集

题目连接:戳ME #include <iostream> #include <cstdio> #include <cstring> using namespace std; const int M = 1e2+5; int n, k; int par[M]; int sum[M]; void find(int x) { if( par[x]!=x ) { sum[par[x]]++; find(par[x]); } else return; } int main() {

HDU OJ 5317 RGCDQ( 2015多校联合训练第3场) 暴力+小技巧

题目连接:戳ME 题意:在一个[L,R]内找到最大的gcd(f[i],f[j])其中L<=i<j<=R,f[x]表示i分解质因数后因子的种类数.eg:f[10]=2(10=2*5),f[12]=2(12=2*2*3). 分析:很容易想到先将f[x]求出来,这里x最大1e6,要在常数时间内求出f[x].并且稍加分析就知道1<=f[x]<=7,可以用一个dp[i][j]表示从f[1]到f[i]有多少个j.这样就可以在常数时间内预处理出来,后面在O(1)的时间内就可以输出结果.并且

2015多校联合训练第三场Painter(hdu5319)

要注意的地方就是并不是n*n的矩阵,列要单独求 dfs一下 #include <bits/stdc++.h> #define LL long long using namespace std; const int MAXN = 1e6; int n,m; char mp[60][60]; int ans; void dfs_R(int x , int y) { if(x >= 0 && x < n && y >= 0 && y

HDU 5371 (2015多校联合训练赛第七场1003)Hotaru&#39;s problem(manacher+二分/枚举)

HDU 5371 题意: 定义一个序列为N序列:这个序列按分作三部分,第一部分与第三部分相同,第一部分与第二部分对称. 现在给你一个长为n(n<10^5)的序列,求出该序列中N序列的最大长度. 思路: 来自官方题解:修正了一些题解错别字(误 先用求回文串的Manacher算法,求出以第i个点为中心的回文串长度,记录到数组p中 要满足题目所要求的内容,需要使得两个相邻的回文串,共享中间的一部分,也就是说,左边的回文串长度的一半,要大于等于共享部分的长度,右边回文串也是一样. 因为我们已经记录下来以

HDU 5371 (2015多校联合训练赛第七场1003)Hotaru&amp;#39;s problem(manacher+二分/枚举)

pid=5371">HDU 5371 题意: 定义一个序列为N序列:这个序列按分作三部分,第一部分与第三部分同样,第一部分与第二部分对称. 如今给你一个长为n(n<10^5)的序列,求出该序列中N序列的最大长度. 思路: 来自官方题解:修正了一些题解错别字(误 先用求回文串的Manacher算法.求出以第i个点为中心的回文串长度.记录到数组p中 要满足题目所要求的内容.须要使得两个相邻的回文串,共享中间的一部分,也就是说.左边的回文串长度的一半,要大于等于共享部分的长度,右边回文串也

2014多校联合训练第一场(组队训练)

这是我.potaty.lmz第二次训练,毕竟经验不足,加上水平不够,导致我们各种被碾压. A - Couple doubi: 这道题是道比较水的数论.但我们都没想出来要怎么做.后来是potaty提议打个表看看,然后lmz打出表后发现了规律.我还没细看,待研究后再补全. D - Task: 这道题一看就知道是个贪心(现在只要是有deadline的题我都觉得是贪心了).虽然想出来了,但还是不会严格证明为什么只要取满足task的且y最小(y相等时x最小)的machine就行了. 我的做法是把所有mac